﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Sockets;
using System.Net;
using System.Threading;

namespace CAsyncSocket
{
    class CAsyncClient
    {
        private Socket _mainSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        private string _textSent = "";
        private byte[] _dataBuffer = new byte[1024];
        private IPEndPoint _serverEndPoint;
        private int _receiveTimeout;
        private string _remoteAddress = "";
        private int _port = 0;
        private string _textReceived = "";
        private byte[] _bytesReceived;

        private static ManualResetEvent receiveDone = new ManualResetEvent(false);

        public CAsyncClient(string IP, int port, int receiveTimeout)
        {
            try
            {
                _port = port;
                _receiveTimeout = receiveTimeout;
                IPAddress ipAddress = IPAddress.Parse(IP);
                _remoteAddress = ipAddress.ToString();
                _serverEndPoint = new IPEndPoint(ipAddress, port);
            }
            catch (Exception ex)
            {
                
            }
        }

        public bool SendText(string mens)
        {
            try
            {
                byte[] byData = System.Text.Encoding.UTF8.GetBytes(mens);
                int NumBytes = _mainSocket.Send(byData);
                if (NumBytes == byData.Length)
                {
                    
                    _textSent = mens;
                   
                    return true;
                }
                else
                    return false;
            }
            catch (ArgumentException se)
            {
               
                return false;
            }
            catch (ObjectDisposedException se)
            {
               
                return false;
            }
            catch (SocketException se)
            {
                
                return false;
            }
        }

        public bool Connect()
        {
            try
            {
                
                _mainSocket.BeginConnect(_serverEndPoint, new AsyncCallback(ConfirmConnect), null);
                return true;
            }
            catch (ArgumentException ex)
            {
               
                return false;
            }
            catch (InvalidOperationException ex)
            {
               
                return false;
            }
            catch (SocketException se)
            {
                return false;
            }
        }

        private void ConfirmConnect(IAsyncResult asyn)
        {
            try
            {
                _mainSocket.EndConnect(asyn);
                WaitForData(_mainSocket);
                
            }
            catch (ObjectDisposedException se)
            {
                
            }
            catch (SocketException se)
            {
                
            }
        }

        private void WaitForData(Socket soc)
        {
            try
            {  
                soc.BeginReceive(_dataBuffer, 0, _dataBuffer.Length, SocketFlags.None, new AsyncCallback(OnDataReceived), null);
                
            }
            catch (SocketException se)
            {
            }
        }

        private void OnDataReceived(IAsyncResult asyn)
        {
            try
            {
                int iRx = _mainSocket.EndReceive(asyn);
                if (iRx < 1)
                {
                    _mainSocket.Close();
                    receiveDone.Set();

                    if (!_mainSocket.Connected)
                    {

                    }
                }
                else
                {
                    _bytesReceived = _dataBuffer;
                    char[] chars = new char[iRx + 1];
                    Decoder d = Encoding.UTF8.GetDecoder();
                    d.GetChars(_dataBuffer, 0, iRx, chars, 0);
                    _textReceived = new String(chars);

                    bool res = receiveDone.WaitOne(10000, false);

                    if (!res)
                    {
                        //timeout 발생 
                    }

                    WaitForData(_mainSocket);

                }
            }
            catch (ArgumentException se)
            {
               
            }
            catch (InvalidOperationException se)
            {
                _mainSocket.Close();
                receiveDone.Set();
                    
            }
            catch (SocketException se)
            {
                
            }
        }
    }
}
