﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Sockets;
using System.Net;
using System.Collections;

namespace CAsyncSocket
{
    class CAsyncServer
    {
        private byte[] _bytesReceived;
        private string _textReceived = "";
        private bool _listening = false;
        private string _textSent = "";
        private IPEndPoint _serverEndPoint;
        IPAddress _ipAddress;
        private int _port = 0;
        private Socket _mainSocket = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
        private ArrayList _clients = ArrayList.Synchronized(new ArrayList());

        public delegate void ConnectionDelegate(Socket soc);
        public event ConnectionDelegate OnRead;

        public CAsyncServer(int port)
        {
            try
            {
                
                IPAddress.TryParse("127.0.0.1", out _ipAddress);

                _port = port;
                _serverEndPoint = new IPEndPoint(_ipAddress, _port);
            }
            catch (Exception ex)
            {

            }
        }

        private class SocketPacket
        {
            public SocketPacket(Socket soc)
            {
                m_currentSocket = soc;
            }
            public Socket m_currentSocket;
            public byte[] dataBuffer = new byte[1024];
        }

        public int ActiveConnections
        {
            get
            {
                return (_clients.Count);
            }
        }

        public string ReceivedText
        {
            get
            {
                string temp = _textReceived;
                _textReceived = "";
                return (temp);
            }
        }

        public bool Active()
        {
            try
            {
                _listening = true;
                _mainSocket.Bind(_serverEndPoint);
                _mainSocket.Listen(0);
                _mainSocket.BeginAccept(new AsyncCallback(OnClientConnect), null);

                return true;
            }
            catch (SocketException se)
            {
                _listening = false;
                return false;
            }
        }

        private void OnClientConnect(IAsyncResult asyn)
        {
            try
            {
                if (_listening)
                {
                    Socket workSocket = _mainSocket.EndAccept(asyn);
                    try
                    {
                        WaitForData(workSocket);
                        lock (this)
                        {
                            _clients.Add(workSocket);
                        }

                        _mainSocket.BeginAccept(new AsyncCallback(OnClientConnect), null);
                    }
                    catch (SocketException se)
                    {

                    }
                }
            }
            catch (ObjectDisposedException ex)
            {
                ;
            }
        }

        public bool Connected(int SocketIndex)
        {
            if ((_clients.Count - 1) >= SocketIndex)
            {
                Socket soc = (Socket)_clients[SocketIndex];
                return soc.Connected;
            }
            else
                return false;
        }


        public bool SendText(string mens, int SocketIndex)
        {
            Socket workerSocket = (Socket)_clients[SocketIndex];
            try
            {
                byte[] byData = System.Text.Encoding.UTF8.GetBytes(mens);
                int NumBytes = workerSocket.Send(byData);
                if (NumBytes == byData.Length)
                {
                    _textSent = mens;

                    return true;
                }
                else
                    return false;
            }
            catch (SocketException ex)
            {

                return false;
            }
        }

        private void WaitForData(Socket soc)
        {
            try
            {
                SocketPacket theSocPkt = new SocketPacket(soc);

                soc.BeginReceive(theSocPkt.dataBuffer, 0, theSocPkt.dataBuffer.Length, SocketFlags.None, new AsyncCallback(ReceiveCallback), theSocPkt);
            }
            catch (SocketException se)
            {
                ;
            }
        }

        private void ReceiveCallback(IAsyncResult asyn)
        {
            SocketPacket socketData = (SocketPacket)asyn.AsyncState;
            try
            {
                int iRx = socketData.m_currentSocket.EndReceive(asyn);
                if (iRx < 1)
                {
                    socketData.m_currentSocket.Close();
                    if (!socketData.m_currentSocket.Connected)
                    {

                        _clients.Remove(socketData.m_currentSocket);
                        socketData.m_currentSocket = null;
                    }
                }
                else
                {

                    _bytesReceived = socketData.dataBuffer;
                    char[] chars = new char[iRx + 1];
                    Decoder d = Encoding.UTF8.GetDecoder();
                    d.GetChars(socketData.dataBuffer, 0, iRx, chars, 0);
                    _textReceived = new String(chars);

                    if (OnRead != null)
                        OnRead(socketData.m_currentSocket);

                    WaitForData(socketData.m_currentSocket);
                }
            }
            catch (InvalidOperationException ex)
            {

            }
        }

    }
}
